#! /usr/bin/python

# Backup /boot and / and create an nfi file
import sys, os

if len(sys.argv) < 2:
	raise "Usage: %s FILE" % (sys.argv[0])

mnts = open("/proc/mounts", "r")

ignores = ''

for line in mnts.readlines():
	mntpt = line.split()[1]
	if mntpt == '/': continue
	ignores += ' --ignore=' + mntpt
mnts.close()

os.environ['PATH'] += ':.'
os.system("mount -o ro,remount /")
# Awful, but just dumping the whole partition won't work
os.system("dd if=/dev/mtd/1 bs=32k of=secondstage.gz")
os.system("gunzip secondstage.gz")
os.system("gzip secondstage")
#
os.system("mkfs.jffs2 -v --root=/boot --faketime --output=boot.jffs2 --eraseblock=0x4000 -n -l")
os.system("mkfs.jffs2 -v --root=/ --faketime --output=root.jffs2 --eraseblock=0x4000 -n -l" + ignores)
os.system("buildimage secondstage.gz boot.jffs2 root.jffs2 dm7025 > " + sys.argv[1])
#
os.unlink("secondstage.gz")
os.unlink("boot.jffs2")
os.unlink("root.jffs2")
os.system("mount -o rw,remount /")
